#ifndef LOG_H
#define LOG_H

#define LOG_MISC	0x1
#define LOG_CPU		0x2
#define LOG_PPU		0x3
#define LOG_CPU_MMAP	0x4
#define LOG_MAPPER	0x5
#define LOG_VERBOSE	0x6
#define LOG_PROFILER	0x7
#define LOG_WARNING	0x10
#define LOG_ERROR	0x20

#define LOG_COLOUR(x)	((x)<<8)

#define LOG_TYPE(x)	((x)<<16)
#define LT_IGNORE	0x100
/*
	1: cpu speed
	2: reset
	3: video format
	4: cart switch
	5: pause
	6: ddraw lock failed
	7: dsound lock failed
*/

#define DEBUG_PROFILER	FALSE	/* optional profiler */
#define DEBUG_CPU	FALSE	/* cpu opcodes */
#define DEBUG_CPU_MMAP	FALSE	/* cpu memory accesses */
#define DEBUG_PPU	FALSE	/* ppu scanline/hblank/vblank */
#define DEBUG_MAPPER	FALSE	/* various mapper related */
#define DEBUG_VERBOSE	FALSE	/* quite useless info */
#define DEBUG_MISC	TRUE	/* quite useful info, false: show only errors/warnings */

#define LOG_DOS_BOX	FALSE	/* compiled with dosbox enabled */
#define LOG_MAX_WIDTH	45	/* maximum number of characters of 1 logged line */

void __cdecl LOG(int,const char*,...);
void LOG_BIN(int,u32,int);
void log_init(void);
void log_set_frame_start(u32);
void log_enable(void);
void log_disable(void);
void log_set_window(HWND);

#endif /* LOG_H */
